/*  Misfit Model 3D
 * 
 *  Copyright (c) 2004-2005 Kevin Worcester
 * 
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, 
 *  USA.
 *
 *  See the COPYING file for full license text.
 */

#include "mm3dport.h"
#include <stdlib.h>
#include <time.h>
#include <string.h>

#include <unistd.h>

char * PORT_getenv( const char * name )
{
#ifdef WIN32
   return "C:/";  // FIXME do registry lookup
#else
   return getenv( name );
#endif // WIN32
}

int PORT_lstat( const char * filename, struct stat * buf )
{
#ifdef WIN32
   return stat( filename, buf );
#else
   return lstat( filename, buf );
#endif // WIN32
}

char * PORT_realpath( const char * path, char * resolved_path, size_t len )
{
#ifdef WIN32
   _fullpath( resolved_path, path, len );
#else
   realpath( path, resolved_path );
#endif // WIN32
   return resolved_path;
}

struct tm * PORT_localtime_r( const time_t * timep, struct tm * result )
{
#ifdef WIN32
   *result = *localtime( timep );
#else
   localtime_r( timep, result );
#endif
   return result;
}

char * PORT_asctime_r( const struct tm * tmval, char * buf )
{
#ifdef WIN32
   char *tmptmstr = asctime( tmval );
   strcpy( buf, tmptmstr );
#else
   asctime_r( tmval, buf );
#endif
   return buf;
}

int PORT_symlink( const char * oldpath, const char * newpath )
{
#ifdef WIN32
   return 0;
#else
   return symlink( oldpath, newpath );
#endif // WIN32
}

int PORT_mkdir( const char * pathname, mode_t mode )
{
#ifdef WIN32
   return mkdir( pathname );
#else
   return mkdir( pathname, mode );
#endif // WIN32
}

